#include <stdio.h>
#include <string.h>
#include <conio.h>


typedef struct {
    char staat[60];
    char hauptstadt[50];
    char einwohner[12];
    char stand[10];
    char quelle[40];
} t_line;


void initLine(t_line *line) {
    line->staat[0] = '\0';
    line->hauptstadt[0] = '\0';
    line->einwohner[0] = '\0';
    line->stand[0] = '\0';
    line->quelle[0] = '\0';
}


/* Liest ein Feld bis zum Trennzeichen.
 * Gibt einen Zeiger auf das naechste Feld zurueck.
 */
char *parseToken(char *start, char *field, char delimiter) {
    while (*start != delimiter && *start != '\0') {
        *field++ = *start++;
    }
    *field = '\0';

    return ++start;
}


/* Zerlegt eine Zeile in Felder.
 */
char *parseLine(char *buf, t_line *line) {
    int i;
    int len;

    initLine(line);

    buf = parseToken(buf, line->staat, ';');
    buf = parseToken(buf, line->hauptstadt, ';');
    buf = parseToken(buf, line->einwohner, ';');
    buf = parseToken(buf, line->stand, ';');
    buf = parseToken(buf, line->quelle, ';');
}


/* Main
 */
int main(void) {
    char filenameIn[13];
    char filenameOut[13];
    FILE *fpIn;
    FILE *fpOut;
    char buf[100];
    t_line line;

    strcpy(filenameIn, "hauptst.csv");
    fpIn = fopen(filenameIn, "r");
    if (fpIn == NULL) {
        printf("Fehler: Eingabedatei %s nicht gefunden!\n", filenameIn);
        return -1;
    }

    strcpy(filenameOut, "extrakt.csv");
    fpOut = fopen(filenameOut, "w");
    if (fpOut == NULL) {
        printf("Fehler: Konnte Ausgabedatei %s nicht oeffnen!\n", filenameOut);
        fclose(fpIn);
        return -1;
    }

    // Zeilen lesen
    while (fgets(buf, sizeof buf, fpIn) != NULL) {
        printf(".");

        // Zeile in Felder aufteilen
        parseLine(buf, &line);

        // Hauptstadt und Einwohner schreiben
        fprintf(fpOut, "%s: %s\r", line.hauptstadt, line.einwohner);
    }

    putchar('\n');

    fclose(fpIn);
    fclose(fpOut);

    return 0;
}
